local broker = LibStub("LibDataBroker-1.1")

local Durability = broker:NewDataObject("Broker_Durability", {
	icon = "Interface\\Icons\\Trade_BlackSmithing",
	label = "Durability",
	suffix = "%"
	}
)
LibStub("AceBucket-3.0"):Embed(Durability)

local format = string.format
local slots = {
	(GetInventorySlotInfo("HeadSlot")),
	(GetInventorySlotInfo("ShoulderSlot")),
	(GetInventorySlotInfo("ChestSlot")),
	(GetInventorySlotInfo("WristSlot")),
	(GetInventorySlotInfo("HandsSlot")),
	(GetInventorySlotInfo("WaistSlot")),
	(GetInventorySlotInfo("LegsSlot")),
	(GetInventorySlotInfo("FeetSlot")),
	(GetInventorySlotInfo("MainHandSlot")),
	(GetInventorySlotInfo("SecondaryHandSlot")),
	(GetInventorySlotInfo("RangedSlot")),
}

local average = true
function Durability.OnClick()
	average = not average
	Durability:Update()
end

local function UpdateItem(slot)
	local link = GetInventoryItemLink("player", slot)
	if not link then return -1 end

	local durability, maximum = GetInventoryItemDurability(slot)
	if not durability or (maximum == 0) then return -1 end

	return (durability/maximum)
end

function Durability:Update()
	local total = 0
	if average then
		local count = 0
		for i = 1, #slots do
			local d = UpdateItem(slots[i])
			if d >= 0 then
				total = total + d
				count = count + 1
			end
		end
		total = total/count
	else
		total = 1
		for i = 1, #slots do
			local d = UpdateItem(slots[i])
			if d >= 0 and d < total then
				total = d
			end
		end
	end
	self.text = format("%i%%", total * 100)
	self.value = format("%i", total * 100)
end

Durability:RegisterBucketEvent({
	"PLAYER_UNGHOST",
	"PLAYER_DEAD",
	"PLAYER_REGEN_ENABLED",
	"UPDATE_INVENTORY_ALERTS",
	"MERCHANT_SHOW",
	"MERCHANT_CLOSED",
}, 1, "Update")

Durability:Update()